<?php 
defined('ABSPATH') or die("No direct script access!");
//<--Registering custom post and Taxonomie for iList

function qcilist_pro_custom_post_text() {
	//Registering Custom Post
		$qc_list_labels = array(
		'name'               => _x( 'Manage iList Items', 'qc-opd' ),
		'singular_name'      => _x( 'Manage iList Item', 'qc-opd' ),
		'add_new'            => _x( 'New iList', 'qc-opd' ),
		'add_new_item'       => __( 'Add New iList', 'qc-opd' ),
		'edit_item'          => __( 'Edit iList Item', 'qc-opd' ),
		'new_item'           => __( 'New iList Item', 'qc-opd' ),
		'all_items'          => __( 'Manage iList Items', 'qc-opd' ),
		'view_item'          => __( 'View iList Item', 'qc-opd' ),
		'search_items'       => __( 'Search List Item', 'qc-opd' ),
		'not_found'          => __( 'No List Item found', 'qc-opd' ),
		'not_found_in_trash' => __( 'No List Item found in the Trash', 'qc-opd' ), 
		'parent_item_colon'  => '',
		'menu_name'			 => __('iList Pro', 'qc-opd')
		
	);
	
	$qc_list_args = array(
		'labels'        		=> $qc_list_labels,
		'description'   		=> __('This post type holds all posts for your directory items.', 'qc-opd' ),
		'exclude_from_search' 	=> true,
		'show_in_menu' 			=> true,
		'supports'      		=> array( 'title' ),
		'menu_icon' 			=> 'dashicons-editor-ol',
		'public' 				=> false,  // it's not public, it shouldn't have it's own permalink, and so on
		'publicly_queryable' 	=> false,  // you should be able to query it
		'show_ui' 				=> true,  // you should be able to edit it in wp-admin
		'exclude_from_search' 	=> true,  // you should exclude it from search results
		'show_in_nav_menus' 	=> false,  // you shouldn't be able to add it to menus
		'has_archive' 			=> false,  // it shouldn't have archive page
		'rewrite' 				=> false,  // it shouldn't have rewrite rules
	);
	
	register_post_type( 'ilist', $qc_list_args );


	$args = array(
	  		'labels'	=>	array(
							'name'               	=> 	__('Build Template', 'qc-opd' ),
							'all_items' 			=> 	__('Build Template', 'qc-opd' ),
							'menu_name'				=>	__('Build Template', 'qc-opd' ),
							'singular_name' 		=>	__('Build Template', 'qc-opd' ),
							'add_new'       		=>  __('New Template', 'qc-opd' ),
							'add_new_item'  		=> 	__('Add New Template', 'qc-opd' ),
						 	'edit_item' 			=>	__('Edit Build Template', 'qc-opd' ),
						 	'new_item'  			=>	__('New Build Template', 'qc-opd' ),
						 	'view_item' 			=>	__('View Build Template', 'qc-opd' ),
						 	'items_archive' 		=>	__('Build Template Archive', 'qc-opd' ),
						 	'search_items'  		=>	__('Search Build Templates', 'qc-opd' ),
						 	'not_found'	    		=>	__('No Build Templates found.', 'qc-opd' ),
						 	'not_found_in_trash'  	=>  __('No Build Templates found in trash.', 'qc-opd' )
						),
		'supports'      =>	array( 'title' ),				
		'show_in_menu'  =>	'edit.php?post_type=ilist',
		'public'		    =>	true
	);
	register_post_type( 'qc_ilist_drag_drop', $args );



// Registering Taxonomies
/*
	$labels = array(
		'name'              => _x( 'iList Categories', 'iList Categories', 'qc-opd' ),
		'singular_name'     => _x( 'Category', 'taxonomy singular name', 'qc-opd' ),
		'search_items'      => __( 'Search iList Categories', 'qc-opd' ),
		'all_items'         => __( 'All iList Categories', 'qc-opd' ),
		'parent_item'       => __( 'Parent iList Categories', 'qc-opd' ),
		'parent_item_colon' => __( 'Parent iList Category:', 'qc-opd' ),
		'edit_item'         => __( 'Edit iList Category', 'qc-opd' ),
		'update_item'       => __( 'Update iList Category', 'qc-opd' ),
		'add_new_item'      => __( 'Add New iList Category', 'qc-opd' ),
		'new_item_name'     => __( 'New iList Category Name', 'qc-opd' ),
		'menu_name'         => __( 'iList Categories', 'qc-opd' ),
	);

	$args = array(
		'hierarchical'      => true,
		'labels'            => $labels,
		'show_ui'           => true,
		'show_admin_column' => true,
		'query_var'         => true,
		'rewrite'           => array( 'slug' => 'sl_cat' ),
	);

	register_taxonomy( 'sl_cat', array( 'ilist' ), $args );
	*/





}
add_action('init', 'qcilist_pro_custom_post_text');
//End Custom Post and Taxonomie-->


function qcilist_pro_openai_meta_box(){

    add_meta_box("qcilist-openai-box", __( "Generate with OpenAI", 'qc-opd' ), "qcilist_pro_custom_meta_box_openai", "ilist", "side", "high");

}
add_action("add_meta_boxes", "qcilist_pro_openai_meta_box");

function qcilist_pro_custom_meta_box_openai($object){
    ?>

    	<div class="qcld_openai_title_generate_wrap">
    		<p><?php echo esc_html('Generate iList Items with OpenAI. ', 'qc-opd'); ?></p>
    		<p><?php echo esc_html('Please add your title first and save the post. Then click Generate.', 'qc-opd'); ?></p>
    		<label for="qcld_openai_number"><?php echo esc_html('Number Of Items:', 'qc-opd'); ?></label>
    		<input type="number" name="qcld_openai_number" id="qcld_openai_number" class="qcld_openai_number" value="6" />
    		<div class="qcld_openai_title_generate_btn"><?php echo esc_html('Generate', 'qc-opd'); ?></div>
    	</div>

    <?php  
}



function qcilist_pro_add_custom_meta_box()
{
    add_meta_box("qcilist-meta-box", __( "Preview Box", "qc-opd" ), "qcilist_pro_custom_meta_box_markup", "ilist", "side");
}

add_action("add_meta_boxes", "qcilist_pro_add_custom_meta_box");


function qcilist_pro_custom_meta_box_markup($object)
{

    ?>
        <div>
            <br>
            <?php if(!empty($object->ID )): ?>
            <a class="ilist-fancybox-show" post-id="<?php echo esc_attr($object->ID); ?>" href="#"><?php esc_html_e('Save & Preview', 'qc-opd'); ?></a>
            <br>
            <p><?php esc_html_e('You can also save as Image from the preview and Get a Shortcode to Embed this iList as Image!', 'qc-opd'); ?></p>
            <p style="color:indianred"><?php echo 'If you are displaying iList as Image instead of HTML, you must <strong>*Save & Preview*</strong> and then click on <strong>*Save as Image*</strong> button after any kind of changes to the iList.'; ?></p>

            <a style="display: none" href="<?php echo site_url(); ?>/embed-ilist/?order=ASC&mode=one&list_id=<?php echo esc_attr($object->ID); ?>&column=1&display_copy_share=true&embed_option=1&main_title=1&upvote=on&boxed_layout=1&capture=true" data-fancybox-type="iframe" class="fancyboxIframe"><?php esc_html_e('Save & Preview', 'qc-opd'); ?></a>
        	<?php endif; ?>

        </div>

    <?php  
}


function qcilist_pro_shortcode_add_custom_meta_box()
{
    add_meta_box("qcilist-shortcode-meta-box", __( "Shortcode", "qc-opd" ), "qcilist_pro_shortcode_custom_meta_box_markup", "ilist", "side");
}

add_action("add_meta_boxes", "qcilist_pro_shortcode_add_custom_meta_box");


function qcilist_pro_shortcode_custom_meta_box_markup($object)
{

    ?>
        <div>
        <?php 

        if(isset($object->ID) && !empty($object->ID ) && ( isset($_GET['action']) && $_GET['action'] == 'edit')){

		    $shortcode_main_title = get_post_meta( $object->ID, 'shortcode_main_title' );
		    $shortcode_embed_option = get_post_meta( $object->ID, 'shortcode_embed_option' );
		    $shortcode_boxed_layout = get_post_meta( $object->ID, 'shortcode_boxed_layout' );
		    $shortcode_column = get_post_meta( $object->ID, 'shortcode_column' );
		    $shortcode_display_copy_share = get_post_meta( $object->ID, 'shortcode_display_copy_share' );
		    $shortcode_upvote = get_post_meta( $object->ID, 'shortcode_upvote' );

		    $post_type_radio_sl = get_post_meta( $object->ID, 'post_type_radio_sl' );

		    if($post_type_radio_sl[0] ==  'textlist' ){ 
		    	$shortcode_list_style = get_post_meta( $object->ID, 'qcld_sl_template_text' );
		    }else if($post_type_radio_sl[0] ==  'imagelist' ){
		    	$shortcode_list_style = get_post_meta( $object->ID, 'qcld_sl_template_image' );
		    }else if($post_type_radio_sl[0] ==  'multipage' ){
		    	$shortcode_list_style = get_post_meta( $object->ID, 'qcld_sl_template_multipage' );
		    }else{
		    	$shortcode_list_style = get_post_meta( $object->ID, 'qcld_sl_template_mix' );
		    }

		    if(!empty($object->ID)){

		    	$shortcode_list_style = ( isset( $shortcode_list_style ) && !empty( $shortcode_list_style ) ) ? $shortcode_list_style[0] : ''; 

	        	$qcld_ilist_shortcode =  '[qcld-ilist mode="one" list_id="'.$object->ID.'" style="'.$shortcode_list_style.'" upvote="'.$shortcode_upvote[0].'" main_title="'.$shortcode_main_title[0].'" embed_option="'.$shortcode_embed_option[0].'" boxed_layout="'.$shortcode_boxed_layout[0].'" column="'.$shortcode_column[0].'" display_copy_share="'.$shortcode_display_copy_share[0].'"] <br> <p> '.esc_html('You can also use the iList Shortcode Generator in your page for additional options.', 'qc-opd').' </p>'; 
				echo $qcld_ilist_shortcode;

		    }

		}elseif(isset($object->ID) && !empty($object->ID)){

        	$qcld_ilist_shortcode =  '[qcld-ilist mode="one" list_id="'.$object->ID.'" style="" upvote="on" main_title="1" embed_option="1" boxed_layout="1" column="2" display_copy_share="true"] <br> <p> '.esc_html('You can also use the iList Shortcode Generator in your page for additional options.', 'qc-opd').' </p>'; 
			echo $qcld_ilist_shortcode;

        
    	}


	?>

        </div>

    <?php  
}


function qcilist_pro_noted_add_custom_meta_box(){

    add_meta_box("qcilist-noted-meta-box", __("Note Box", 'qc-opd'), "qcilist_pro_noted_custom_meta_box_markup", "ilist", "side");
}

add_action("add_meta_boxes", "qcilist_pro_noted_add_custom_meta_box");


function qcilist_pro_noted_custom_meta_box_markup($object)
{

    ?>
        <div>
            <?php 

	            if(isset($object->ID) && !empty($object->ID)): 

	            	$qcld_ilist_shortcode =  "<p style='color:indianred'>".esc_html('NB: iLists must be published before you add the shortcode to a page. iLists won\'t display on your page if it is in Draft mode. Don\'t worry, your iLists won\'t show until you add the shortcode to a page or post.', 'qc-opd')."</p>"; 
					echo $qcld_ilist_shortcode;
	            
	        	endif; 

        	?>

        </div>

    <?php  
}

//File Required for metabox

require_once( QCOPD_INC_DIR1 . '/CMB2/cmb2-conditionals.php' );
require_once QCOPD_INC_DIR1 . '/CMB2/init.php';
require_once QCOPD_INC_DIR1 . '/grid-master/Cmb2GridPlugin.php';


//<--Registering repeatable group field metabox.


add_action( 'cmb2_admin_init', 'qcilist_pro_shortcode_register_appearance_metabox' );
function qcilist_pro_shortcode_register_appearance_metabox() {
	
	$cmb_shortcode = new_cmb2_box( array(
		'id'            => 'ilist_shortcode_conf',
		'title'         => esc_html__( 'Shortcode Settings', 'qc-opd' ),
		'object_types'  => array( 'ilist' ), // Post type
		 'closed'     	=> true,
		 'classes'    	=> 'extra-class',
		 

	) );


	// shortcode feature...
	$shortcode_1 = $cmb_shortcode->add_field( array(
		'name'    	=> __( 'Main Title', 'qc-opd' ),
		'id'      	=> 'shortcode_main_title',
		'type'    	=> 'radio_inline',
		'options' 	=> array(
			'1' 	=> __( 'Yes', 'qc-opd' ),
			'0' 	=> __( 'No', 'qc-opd' ),
		),
		'default' 	=> '1',
	) );

	$shortcode_2 = $cmb_shortcode->add_field( array(
		'name'    	=> __( 'Embed Option', 'qc-opd' ),
		'id'      	=> 'shortcode_embed_option',
		'type'    	=> 'radio_inline',
		'options' 	=> array(
			'1' 	=> __( 'Yes', 'qc-opd' ),
			'0' 	=> __( 'No', 'qc-opd' ),
		),
		'default' 	=> '1',
	) );


	$shortcode_3 = $cmb_shortcode->add_field( array(
		'name'    	=> __( 'Boxed Layout', 'qc-opd' ),
		'id'      	=> 'shortcode_boxed_layout',
		'type'    	=> 'radio_inline',
		'options' 	=> array(
			'1' 	=> __( 'Yes', 'qc-opd' ),
			'0' 	=> __( 'No', 'qc-opd' ),
		),
		'default' 	=> '1',
	) );

	$shortcode_4 = $cmb_shortcode->add_field( array(
		'name'    	=> __( 'Column', 'qc-opd' ),
		'id'      	=> 'shortcode_column',
		'type'    	=> 'radio_inline',
		'options' 	=> array(
			'1' 	=> __( '1', 'qc-opd' ),
			'2' 	=> __( '2', 'qc-opd' ),
		),
		'default' 	=> '2',
	) );


	$shortcode_5 = $cmb_shortcode->add_field( array(
		'name'    	=> __( 'Display Copy Share', 'qc-opd' ),
		'id'      	=> 'shortcode_display_copy_share',
		'type'    	=> 'radio_inline',
		'options' 	=> array(
			'true' 	=> __( 'Yes', 'qc-opd' ),
			'false' => __( 'No', 'qc-opd' ),
		),
		'default' 	=> 'true',
	) );
	$shortcode_6 = $cmb_shortcode->add_field( array(
		'name'    	=> __( 'Upvote', 'qc-opd' ),
		'id'      	=> 'shortcode_upvote',
		'type'    	=> 'radio_inline',
		'options' 	=> array(
			'on' 	=> __( 'Yes', 'qc-opd' ),
			'off' 	=> __( 'No', 'qc-opd' ),
		),
		'default' 	=> 'on',
	) );

// shortcode feature...
//Code for create column
$cmb2Grid = new \Cmb2Grid\Grid\Cmb2Grid($cmb_shortcode);
// shortcode generate...
$row = $cmb2Grid->addRow();
$row->addColumns(array($shortcode_1, $shortcode_2,$shortcode_3));
$row = $cmb2Grid->addRow();
$row->addColumns(array($shortcode_4, $shortcode_5,$shortcode_6));
	

}

add_action( 'cmb2_admin_init', 'qcilist_pro_register_sl_repeatable_group_field_metabox' );
function qcilist_pro_register_sl_repeatable_group_field_metabox(){

if(!is_admin()){
    return;
}
// Finding array template //

	$prefix = '_sl_';
	$cmb_group = new_cmb2_box( array(
		'id'           => $prefix . 'metabox',
		'title'        => esc_html__( 'List Elements', 'qc-opd' ),
		'object_types' => array( 'ilist' ),
	) );
	// Creating post type
	$cmb_group->add_field( array(
		'name'    		=> __( 'Select List Type', 'qc-opd' ),
		'id'      		=> 'post_type_radio_sl',
		'type'    		=> 'radio_inline',
		'options' 		=> array(
			'textlist' 	=> __( 'Info Lists', 'qc-opd' ),
			'imagelist' => __( 'Graphic Lists', 'qc-opd' ),
			'elegant' 	=> __( 'Infographics', 'qc-opd' ),
			'multipage' => __( 'Multi Page', 'qc-opd' ),
		),
		'default' 		=> 'elegant',
	) );
	//<--Template Part goes here


	// Template for Image list

	$cmb_group->add_field( array(
		'name'             	=> __('Choose Template', 'qc-opd' ),
		'desc'    			=> __( '', 'qc-opd' ),
		'id'               	=> 'qcld_sl_template_image',
		'type'             	=> 'text',
		'attributes' 		=> array(
			
			'data-conditional-id'    => 'post_type_radio_sl',
			'data-conditional-value' => 'imagelist',
		)
		
	) );

	//Template for iList

	$cmb_group->add_field( array(
		'name'             	=> __('Choose Template', 'qc-opd' ),
		'desc'    			=> __( '', 'qc-opd' ),
		'id'               	=> 'qcld_sl_template_text',
		'type'             	=> 'text',
		'attributes' 		=> array(
			
			'data-conditional-id'    => 'post_type_radio_sl',
			'data-conditional-value' => 'textlist',
		)
		
	) );

	//Template for Elegant List
	
	$cmb_group->add_field( array(
		'name'             	=> __('Choose Template', 'qc-opd' ),
		'desc'    			=> __( '', 'qc-opd' ),
		'id'               	=> 'qcld_sl_template_mix',
		'type'             	=> 'text',
		'attributes' 		=> array(
			
			'data-conditional-id'    => 'post_type_radio_sl',
			'data-conditional-value' => 'elegant',
		)
		
	) );
	
	$cmb_group->add_field( array(
		'name'             	=> __('Choose Template', 'qc-opd' ),
		'desc'    			=> __( '', 'qc-opd' ),
		'id'               	=> 'qcld_sl_template_multipage',
		'type'             	=> 'text',
		'attributes' 		=> array(
			
			'data-conditional-id'    => 'post_type_radio_sl',
			'data-conditional-value' => 'multipage',
		)
		
	) );

	//END of template Part-->

	$field1=$cmb_group->add_field( array(
	    'name'    => __('List Holder Color', 'qc-opd' ),
	    'id'      => 'ilist_holder_color',
	    'type'    => 'colorpicker',
	    'default' => '',
	) );
	$field10=$cmb_group->add_field( array(
	    'name'    => __('Entry Number Color', 'qc-opd' ),
	    'id'      => 'ilist_itemnumber_color',
	    'type'    => 'colorpicker',
	    
	    'default' => '',
	) );

	$field5=$cmb_group->add_field( array(
	    'name'    => __('Entry Border/Seperator Color', 'qc-opd' ),
	    'id'      => 'ilist_border_color',
	    'type'    => 'colorpicker',
	    'default' => '',

	) );



	$field2=$cmb_group->add_field( array(
	    'name'    => __('Entry Background Color', 'qc-opd' ),
	    'id'      => 'ilist_item_bgcolor',
	    'type'    => 'colorpicker',
	    'default' => '',

	) );
	$field3=$cmb_group->add_field( array(
	    'name'    => __('Entry Title/FA Icon color', 'qc-opd' ),
	    'id'      => 'ilist_title_color',
	    'type'    => 'colorpicker',
	    'default' => '',

	) );
	$field4=$cmb_group->add_field( array(
	    'name'    => __('Entry Description color', 'qc-opd' ),
	    'id'      => 'ilist_subtitle_color',
	    'type'    => 'colorpicker',
	    'default' => '',

	) );



	$field6=$cmb_group->add_field( array(
	    'name'    => __('Entry Background Hover Color', 'qc-opd' ),
	    'id'      => 'ilist_hoverbg_color',
	    'type'    => 'colorpicker',
	    'default' => '',
	) );
	$field8=$cmb_group->add_field( array(
	    'name'    => __('Entry Title Hover Color', 'qc-opd' ),
	    'id'      => 'ilist_hover_title_color',
	    'type'    => 'colorpicker',
	    'default' => '',
	) );
	$field7=$cmb_group->add_field( array(
	    'name'    => __('Entry Description Hover Color', 'qc-opd' ),
	    'id'      => 'ilist_hover_desc_color',
	    'type'    => 'colorpicker',
	    'default' => '',
	) );


	//End of color option
	//Code Start for Font


	$field21 = $cmb_group->add_field( array(
			'name'             	=> '',
			'id'               	=> 'ilist_title_font_size',
			'type'             	=> 'text',
			'show_option_none' 	=> true,
			'attributes'  		=> array(
				'placeholder' 	=> __('Custom Title Font Size in px (Example: 25)', 'qc-opd' ),
				
			),
			
		) );
	$field22 = $cmb_group->add_field( array(
			'name'             	=> '',
			'id'               	=> 'ilist_desc_font_size',
			'type'             	=> 'text',
			'show_option_none' 	=> true,
			'attributes'  		=> array(
				'placeholder' 	=> __('Custom Description Font Size in px (Example: 25)', 'qc-opd' ),
				
			),
			
		) );
	$tfont = $cmb_group->add_field( array(
			'name'             		=> __('Select Title Font (Pre-Loaded)', 'qc-opd' ),
			'id'               		=> 'ilist_title_font',
			'type'             		=> 'select',
			'show_option_none' 		=> true,
			'options'          		=> array(
				'Roboto'   			=> 'Roboto',
				'Aref Ruqaa'        => 'Aref Ruqaa',
				'Open Sans'         => 'Open Sans',
				'Droid Sans'   		=> 'Droid Sans',
				'Lora'   			=> 'Lora',
				'Nova Script'   	=> 'Nova Script',
				'Droid Serif'   	=> 'Droid Serif',
				'Playfair Display'  => 'Playfair Display',
				'PT Sans Narrow'   	=> 'PT Sans Narrow',
				'Ubuntu'   			=> 'Ubuntu',
				'Montserrat'   		=> 'Montserrat',
				'Raleway'   		=> 'Raleway',
				'Bitter'   			=> 'Bitter',
				'Sonsie One'   		=> 'Sonsie One',
				'Exo'   			=> 'Exo',
				'Others'   			=> 'Other',
			),
			
		) );
	$totherfont = $cmb_group->add_field( array(
	    'name'    => __( 'Other Google Font URL', 'qc-opd' ),
	    'id'      => 'ilist_title_other_font',
	    'type'    => 'text',
	    
		'attributes'  		=> array(
			'placeholder' 	=> 'https://fonts.googleapis.com/css?family=Abril+Fatface',
		),

	) );
	//for Description font
	$dfont = $cmb_group->add_field( array(
		'name'             		=> __( 'Select Description Font (Pre-Loaded)', 'qc-opd' ),
		'id'               		=> 'ilist_desc_font',
		'type'             		=> 'select',
		'show_option_none' 		=> true,
		'options'          		=> array(
			'Roboto'   			=> 'Roboto',
			'Aref Ruqaa'        => 'Aref Ruqaa',
			'Open Sans'         => 'Open Sans',
			'Droid Sans'   		=> 'Droid Sans',
			'Lora'   			=> 'Lora',
			'Nova Script'   	=> 'Nova Script',
			'Droid Serif'   	=> 'Droid Serif',
			'Playfair Display'  => 'Playfair Display',
			'PT Sans Narrow'   	=> 'PT Sans Narrow',
			'Ubuntu'   			=> 'Ubuntu',
			'Montserrat'   		=> 'Montserrat',
			'Raleway'   		=> 'Raleway',
			'Bitter'   			=> 'Bitter',
			'Sonsie One'   		=> 'Sonsie One',
			'Exo'   			=> 'Exo',
			'Others'   			=> 'Other',
		),
		
	) );
		
	$dotherfont = $cmb_group->add_field( array(
	    'name'    => __( 'Other Google Font URL', 'qc-opd' ),
	    'id'      => 'ilist_desc_other_font',
	    'type'    => 'text',
	    
		'attributes'  		=> array(
			'placeholder' 	=> 'https://fonts.googleapis.com/css?family=Abril+Fatface',
			
		),

	) );
	//creating chart for ilist
	$chartfield1 = $cmb_group->add_field( array(
	    'name'    => __( 'Create iList Chart', 'qc-opd' ),
	    'id'      => 'ilist_chart',
	    'type'    => 'text',
	    

	) );
	//display position
	$chartfield2 = $cmb_group->add_field( array(
			'name'    		=> __( 'Show Chart / Image On', 'qc-opd' ),
			'id'      		=> 'show_chart_position',
			'type'    		=> 'radio_inline',
			'options' 		=> array(
				'top' 		=> __( 'Top', 'cmb2' ),
				'middle' 	=> __( 'Middle', 'cmb2' ),
				'bottom' 	=> __( 'Bottom', 'cmb2' ),
			)
			
		) );

	$chartImgfield1 = $cmb_group->add_field( array(
	    'name'    		=> __( 'List Middle Image', 'qc-opd'),
	    'id'      		=> 'ilist_holder_bg_image',
	    'type'    		=> 'file',
	    'default' 		=> '',
		    'options' 	=> array(
	        'url' 		=> false, // Hide the text input for the url
	    ),
	    'text'    		=> array(
	        'add_upload_file_text' => __( 'Add File', 'qc-opd' ) // Change upload button text. Default: "Add or Upload File"
	    ),

	) );

		
	$chartImgfield2 = 	$cmb_group->add_field( array(
		'name' 				=> __( 'List Middle Image Animation', 'qc-opd' ),
		'id'   				=> 'qcld_css_animation_global',
		'description' 		=> __( '', 'qc-opd' ),
        'show_option_none' 	=> true,
        'default'          	=> 'false',
		'classes' 			=> 'ilist-animated-global',
		'type' 				=> 'select',
		'options' 			=> array(
                'bounce'   		=> __( 'bounce', 'qc-opd' ),
                'flash'   		=> __( 'flash', 'qc-opd' ),
                'pulse'   		=> __( 'pulse', 'qc-opd' ),
                'rubberBand'   	=> __( 'rubberBand', 'qc-opd' ),
                'shake'   		=> __( 'shake', 'qc-opd' ),
                'swing'   		=> __( 'swing', 'qc-opd' ),
                'tada'   		=> __( 'tada', 'qc-opd' ),
                'wobble'   		=> __( 'wobble', 'qc-opd' ),

                'bounceIn'   		=> __( 'bounceIn', 'qc-opd' ),
                'bounceInDown'   	=> __( 'bounceInDown', 'qc-opd' ),
                'bounceInLeft'   	=> __( 'bounceInLeft', 'qc-opd' ),
                'bounceInRight'   	=> __( 'bounceInRight', 'qc-opd' ),
                'bounceInUp'   		=> __( 'bounceInUp', 'qc-opd' ),

                'fadeIn'   			=> __( 'fadeIn', 'qc-opd' ),
                'fadeInDown'   		=> __( 'fadeInDown', 'qc-opd' ),
                'fadeInDownBig'   	=> __( 'fadeInDownBig', 'qc-opd' ),
                'fadeInLeft'   		=> __( 'fadeInLeft', 'qc-opd' ),
                'fadeInLeftBig'   	=> __( 'fadeInLeftBig', 'qc-opd' ),
                'fadeInRight'   	=> __( 'fadeInRight', 'qc-opd' ),
                'fadeInRightBig'   	=> __( 'fadeInRightBig', 'qc-opd' ),
                'fadeInUp'   		=> __( 'fadeInUp', 'qc-opd' ),
                'fadeInUpBig'   	=> __( 'fadeInUpBig', 'qc-opd' ),

                'flip'   			=> __( 'flip', 'qc-opd' ),
                'flipInX'   		=> __( 'flipInX', 'qc-opd' ),
                'flipInY'   		=> __( 'flipInY', 'qc-opd' ),
                'lightSpeedIn'   	=> __( 'lightSpeedIn', 'qc-opd' ),

                'rotateIn'   		=> __( 'rotateIn', 'qc-opd' ),
                'rotateInDownLeft'  => __( 'rotateInDownLeft', 'qc-opd' ),
                'rotateInDownRight' => __( 'rotateInDownRight', 'qc-opd' ),
                'rotateInUpLeft'   	=> __( 'rotateInUpLeft', 'qc-opd' ),
                'rotateInUpRight'   => __( 'rotateInUpRight', 'qc-opd' ),

                'slideInLeft'     	=> __( 'slideInLeft', 'qc-opd' ),
                'slideInRight'     	=> __( 'slideInRight', 'qc-opd' ),
                'slideInDown'     	=> __( 'slideInDown', 'qc-opd' ),
		),
		'attributes' => array(
			'data-animation-id'    => 'animation_type',
		)
	) );

	 //display position
	$chartImgfield3 = $cmb_group->add_field( array(
		'name'    	=> __( 'Enable / Disable json-ld', 'qc-opd' ),
		'id'      	=> 'qcld_enable_disable_json_id',
		'type'    	=> 'radio_inline',
		'options' 	=> array(
			'1' 	=> __( 'Enable', 'qc-opd' ),
			'0' 	=> __( 'Disable', 'qc-opd' ),
		),
		'default' 	=> '1',
		
	) );

	// Code start for Group field
	$group_field_id = $cmb_group->add_field( array(
		'id'          => 'qcld_text_group',
		'type'        => 'group',
		'description' => esc_html__( 'Create Text List Elements', 'qc-opd' ),
		'options'     => array(
			'group_title'   => esc_html__( 'Entry {#}', 'qc-opd' ), // {#} gets replaced by row number
			'add_button'    => esc_html__( 'Add Another Entry', 'qc-opd' ),
			'remove_button' => esc_html__( 'Remove Entry', 'qc-opd' ),
			'sortable'      => true, // beta
			
		),
	) );

	// Group Title
	$sl_openai_auto_generate_enable = ot_get_option('sl_openai_auto_generate_enable');
	$qcld_openai_generate 			= '';
	//$qcld_openai_generate 			= ($sl_openai_auto_generate_enable == 'on') ? '<div class="qcld_openai_generate_btn">'.esc_html('Generate').'</div>' : '';

	$cmb_group->add_group_field( $group_field_id, array(
		'name'       	=> esc_html__( 'Entry Title', 'qc-opd' ),
		'description' 	=> $qcld_openai_generate,
		'id'         	=> 'qcld_text_title',
		'type'       	=> 'text',
		
	) );





/*
	Description field with wysiwyg Editor
	It will be visible only for Simple and Elegant List
*/
	$disable_media_buttons = ot_get_option('ilist_disable_media_buttons');

	$qcld_media_button = true;
	if ($disable_media_buttons == 'on') {
		$qcld_media_button = false;
	}

	$cmb_group->add_group_field( $group_field_id, array(
		'name'        		=> esc_html__( 'Description', 'qc-opd' ),
		'description' 		=> esc_html__( 'Write a short description for this entry', 'qc-opd' ),
		'id'          		=> 'qcld_text_desc',
		'type'    			=> 'wysiwyg',
		'options' 			=> array(
			'wpautop' 		=> false,
			'media_buttons' => $qcld_media_button, 
			'tabindex' 		=> '',
			'editor_css' 	=> '',
			'editor_class' 	=> '', 		// add extra class(es) to the editor textarea
			'teeny' 		=> false, 	// output the minimal editor config used in Press This
			'dfw' 			=> false, 	// replace the default fullscreen with DFW (needs specific css)
			'tinymce' 		=> true, 	// load TinyMCE, can be used to pass settings directly to TinyMCE using an array()
			'quicktags' 	=> true,
			'textarea_rows' => 1,
		),
		'after_field' 		=> '<input type="hidden" name="another_test_field" data-conditional-id="post_type_radio_sl" data-conditional-value='.wp_json_encode( array( 'textlist', 'elegant' , 'multipage' ) ).'>',


	) );
	$cmb_group->add_group_field( $group_field_id, array(
		'name'        		=> esc_html__( 'Long Description', 'qc-opd' ),
		'description' 		=> '<span class="multiplage_long_desc_text">This field is optional. If you write a long description for this entry that will display in a lightbox when clicked.</span>',
		'id'          		=> 'qcld_text_long_desc',
		'type'    			=> 'wysiwyg',
		'options' 			=> array(
			'wpautop' 		=> false,
			'media_buttons' => $qcld_media_button, // show insert/upload button(s)
			'textarea_rows' => get_option('default_post_edit_rows', 5), // rows="..."
			'tabindex' 		=> '',
			'editor_css' 	=> '',
			'editor_class' 	=> '', // add extra class(es) to the editor textarea
			'teeny' 		=> false, // output the minimal editor config used in Press This
			'dfw' 			=> false, // replace the default fullscreen with DFW (needs specific css)
			'tinymce' 		=> true, // load TinyMCE, can be used to pass settings directly to TinyMCE using an array()
			'quicktags' 	=> true // load Quicktags, can be used to pass settings directly to Quicktags using an array()
		),
		'after_field' 		=> '<input type="hidden" name="another_test_field" data-conditional-id="post_type_radio_sl" data-conditional-value='.wp_json_encode( array( 'textlist', 'elegant', 'multipage' ) ).'>',

	) );

	$cmb_group->add_group_field( $group_field_id, array(
		'name'        		=> esc_html__( 'Text/Ad Area', 'qc-opd' ),
		'description' 		=> esc_html__( 'Text/Ad Area for this entry. Max width: 1000px, Height: 100px', 'qc-opd' ),
		'id'          		=> 'qcld_multipage_ads_desc',
		'type'    			=> 'wysiwyg',
		'options' 			=> array(
			'wpautop' 		=> false,
			'media_buttons' => $qcld_media_button, // show insert/upload button(s)
			'tabindex' 		=> '',
			'editor_css' 	=> '',
			'editor_class' 	=> '', // add extra class(es) to the editor textarea
			'teeny' 		=> false, // output the minimal editor config used in Press This
			'dfw' 			=> false, // replace the default fullscreen with DFW (needs specific css)
			'tinymce' 		=> true, // load TinyMCE, can be used to pass settings directly to TinyMCE using an array()
			'quicktags' 	=> true,
			'textarea_rows' => 1,
		),
		'after_field' 		=> '<input type="hidden" name="another_test_field" data-conditional-id="post_type_radio_sl" data-conditional-value='.wp_json_encode( array( 'multipage' ) ).'>',


	) );

	$cmb_group->add_group_field( $group_field_id, array(
		'name'        		=> esc_html__( 'Show Text/Ad Area', 'qc-opd' ),
		'description' 		=> esc_html__( 'Show Text/Ad Area Position', 'qc-opd' ),
		'id'          		=> 'qcld_multipage_ads_position',
		'type'    			=> 'radio_inline',
		'options' 			=> array(
			'top' 			=> __( 'Top', 'cmb2' ),
			'bottom' 		=> __( 'Bottom', 'cmb2' ),
		),
		'default' 			=> 'top',
		'after_field' 		=> '<input type="hidden" name="another_test_field" data-conditional-id="post_type_radio_sl" data-conditional-value='.wp_json_encode( array( 'multipage' ) ).'>',


	) );


	$cmb_group->add_group_field( $group_field_id, array(
		'name'       => esc_html__( 'Entry Background Color', 'qc-opd' ),
		'id'         => 'qcld_entrybg_color',
		'type'       => 'colorpicker',
		
	) );	

/*
	Image Uploader
	It will be visible only for Image and Elegant List
*/
	$chartfieldMarge1 =  $cmb_group->add_group_field( $group_field_id, array(
		'name' 			=> esc_html__( 'Font Awesome Icon', 'qc-opd' ),
		'id'   			=> 'qcld_text_image_fa',
		'type' 			=> 'text_medium',
		'classes' 		=> 'ilist_fa_icon',
		'attributes' 	=> array(
			
			'data-conditional-id'    => 'post_type_radio_sl',
			'data-conditional-value' => wp_json_encode( array( 'textlist', 'elegant' ) ),
		)
	) );
	$chartfieldMarge2 =  $cmb_group->add_group_field( $group_field_id, array(
		'name' 			=> esc_html__( 'Progress Bar', 'qc-opd' ),
		'id'   			=> 'qcld_progress_bar',
		'description' 	=> esc_html__( 'Supported Value integer Ex: 50', 'cmb2' ),
		'type' 			=> 'text_medium',
		'attributes' 	=> array(
			
			'data-conditional-id'    => 'post_type_radio_sl',
			'data-conditional-value' => wp_json_encode( array( 'textlist', 'elegant', 'multipage' ) ),
		)
	) );
	
	
	
	$cmb_group->add_group_field( $group_field_id, array(
		'name' 			=> esc_html__( 'Graphics', 'qc-opd' ),
		'id'   			=> 'qcld_text_image',
		'description' 	=>  '<span class="multiplage_desc_text">Image Size: width: 1000px, Height: 500px</span>',
		'type' 			=> 'file',
		'repeatable' 	=> true,
		'attributes' 	=> array(
			
			'data-conditional-id'    => 'post_type_radio_sl',
			'data-conditional-value' => wp_json_encode( array( 'imagelist', 'elegant', 'multipage' ) ),
		)
	) );
	
	$cmb_group->add_group_field( $group_field_id, array(
		'name' 			=> esc_html__( 'Graphic Link', 'qc-opd' ),
		'id'   			=> 'qcld_image_link',
		'description' 	=> esc_html__( '', 'cmb2' ),
		'type' 			=> 'text',
		'attributes' 	=> array(
			
			'data-conditional-id'    => 'post_type_radio_sl',
			'data-conditional-value' => wp_json_encode( array( 'textlist', 'elegant' ) ),
		)
	) );
	
	$cmb_group->add_group_field( $group_field_id, array(
		'name' 				=> esc_html__( 'CSS Animation', 'qc-opd' ),
		'id'   				=> 'qcld_css_animation',
		'description' 		=> esc_html__( '', 'cmb2' ),
        'show_option_none' 	=> true,
        'default'          	=> 'false',
		'classes' 			=> 'ilist-animated-wrap',
		'type' 				=> 'select',
		'options' 			=> array(
                'bounce'   			=> __( 'bounce', 'qc-opd' ),
                'flash'   			=> __( 'flash', 'qc-opd' ),
                'pulse'   			=> __( 'pulse', 'qc-opd' ),
                'rubberBand'   		=> __( 'rubberBand', 'qc-opd' ),
                'shake'   			=> __( 'shake', 'qc-opd' ),
                'swing'   			=> __( 'swing', 'qc-opd' ),
                'tada'   			=> __( 'tada', 'qc-opd' ),
                'wobble'   			=> __( 'wobble', 'qc-opd' ),

                'bounceIn'   		=> __( 'bounceIn', 'qc-opd' ),
                'bounceInDown'   	=> __( 'bounceInDown', 'qc-opd' ),
                'bounceInLeft'   	=> __( 'bounceInLeft', 'qc-opd' ),
                'bounceInRight'   	=> __( 'bounceInRight', 'qc-opd' ),
                'bounceInUp'   		=> __( 'bounceInUp', 'qc-opd' ),

                'fadeIn'   			=> __( 'fadeIn', 'qc-opd' ),
                'fadeInDown'   		=> __( 'fadeInDown', 'qc-opd' ),
                'fadeInDownBig'   	=> __( 'fadeInDownBig', 'qc-opd' ),
                'fadeInLeft'   		=> __( 'fadeInLeft', 'qc-opd' ),
                'fadeInLeftBig'   	=> __( 'fadeInLeftBig', 'qc-opd' ),
                'fadeInRight'   	=> __( 'fadeInRight', 'qc-opd' ),
                'fadeInRightBig'   	=> __( 'fadeInRightBig', 'qc-opd' ),
                'fadeInUp'   		=> __( 'fadeInUp', 'qc-opd' ),
                'fadeInUpBig'   	=> __( 'fadeInUpBig', 'qc-opd' ),

                'flip'   			=> __( 'flip', 'qc-opd' ),
                'flipInX'   		=> __( 'flipInX', 'qc-opd' ),
                'flipInY'   		=> __( 'flipInY', 'qc-opd' ),
                'lightSpeedIn'   	=> __( 'lightSpeedIn', 'qc-opd' ),

                'rotateIn'   		=> __( 'rotateIn', 'qc-opd' ),
                'rotateInDownLeft'  => __( 'rotateInDownLeft', 'qc-opd' ),
                'rotateInDownRight' => __( 'rotateInDownRight', 'qc-opd' ),
                'rotateInUpLeft'   	=> __( 'rotateInUpLeft', 'qc-opd' ),
                'rotateInUpRight'   => __( 'rotateInUpRight', 'qc-opd' ),

                'slideInLeft'     	=> __( 'slideInLeft', 'qc-opd' ),
                'slideInRight'     	=> __( 'slideInRight', 'qc-opd' ),
                'slideInDown'     	=> __( 'slideInDown', 'qc-opd' ),
		),
		'attributes' => array(
			
			'data-conditional-id'    => 'post_type_radio_sl',
			'data-conditional-value' => wp_json_encode( array( 'textlist', 'elegant' ) ),
		)
	) );


	//hidden field//

	$cmb_group->add_group_field( $group_field_id, array(
		'name' 		=> esc_html__( 'thumbs up', 'qc-opd' ),
		'id'   		=> 'sl_thumbs_up',
		'type' 		=> 'text',
		'classes' 	=> 'hidden-class'
	) );
	$cmb_group->add_group_field( $group_field_id, array(
		'name' 		=> esc_html__( 'thumbs user', 'qc-opd' ),
		'id'   		=> 'sl_thumbs_up_user',
		'type' 		=> 'text',
		'classes' 	=> 'hidden-class'
	) );


//Code for create column
$cmb2Grid = new \Cmb2Grid\Grid\Cmb2Grid( $cmb_group );



$row = $cmb2Grid->addRow();
$row->addColumns( array( $field2, $field3, $field4 ) );


$row6 = $cmb2Grid->addRow();
$row6->addColumns(array($chartfield1, $chartfield2));

$row6 = $cmb2Grid->addRow();
$row6->addColumns(array($chartImgfield1, $chartImgfield2));

$row1 = $cmb2Grid->addRow();
$row1->addColumns(array($field6, $field8, $field7));
//font column managment
//$row4 = $cmb2Grid->addRow();
//$row4->addColumns(array($field1, $field11));

$row5 = $cmb2Grid->addRow();
$row5->addColumns(array($field1, $field10,$field5));

$row2 = $cmb2Grid->addRow();
$row2->addColumns(array($tfont, $totherfont));

$row8 = $cmb2Grid->addRow();
$row8->addColumns(array($field21, $field22));
//font column managment desc

// $row7 = $cmb2Grid->addRow();
// $row7->addColumns(array($chartfieldMarge1, $chartfieldMarge2));

$row3 = $cmb2Grid->addRow();
$row3->addColumns(array($dfont, $dotherfont));




//Code for create column

}

//End of repeatable group field metabox.-->



//Custom Columns for Directory Listing
function qcilist_pro_text_list_column_head($defaults) {

    $new_columns['cb'] 							= '<input type="checkbox" />';
    $new_columns['title'] 						= __('Title', 'qc-opd');

    $new_columns['qcld_item_text_count'] 		= __('Number of Elements', 'qc-opd');
	$new_columns['qcilist_pro_item_category'] 	= __('List Type', 'qc-opd');
    $new_columns['shortcode_text_col'] 			= 'Shortcode';
    $new_columns['date'] 						= __('Date', 'qc-opd');
	unset($new_columns['ilist_itemnumber_color']);
    return $new_columns;
}
 
//Custom Columns Data for Backend Listing
function qcilist_pro_list_text_columns_content($column_name, $post_ID) {
    

    if (isset($column_name) && ($column_name == 'qcld_item_text_count')) {
        $cntpost = get_post_meta( $post_ID, 'qcld_text_group' );
		if(isset($cntpost[0]) && is_array($cntpost[0])){
			echo count($cntpost[0]);
		}else{
			echo '0';
		}
		
    }
    if (isset($column_name) && ($column_name == 'qcilist_pro_item_category')) {

        $terms = get_post_meta( $post_ID, 'post_type_radio_sl');

        $terms = isset( $terms[0] ) && !empty( $terms[0] ) ? $terms[0] : '';

		if( $terms == 'textlist' ){
			echo __('Info List', 'qc-opd');
		}
		if( $terms == 'imagelist' ){
			echo __('Graphic List', 'qc-opd');
		}
		if( $terms == 'elegant' ){
			echo __('Infographic List', 'qc-opd');
		}

    }
    if (isset($column_name) && ($column_name == 'shortcode_text_col')) {
        echo '[qcld-ilist mode="one" list_id="'.$post_ID.'"]';
    }
}

add_filter('manage_ilist_posts_columns', 'qcilist_pro_text_list_column_head');
add_action('manage_ilist_posts_custom_column', 'qcilist_pro_list_text_columns_content', 10, 2);


function qcilist_pro_admin_enqueue_scripts_stylesss() {
    
    wp_register_style( 'ilist-tinymce-style-css', QCOPD_ASSETS_URL1. '/css/style.css');
    wp_enqueue_style( 'ilist-tinymce-style-css' );

}
add_action( 'admin_enqueue_scripts', 'qcilist_pro_admin_enqueue_scripts_stylesss');
/*TinyMCE button for Inserting Shortcode*/
/* Add Slider Shortcode Button on Post Visual Editor */
function qcilist_pro_tinymce_button_function() {
	add_filter ("mce_external_plugins", "qcilist_pro_sld_btn_js");
	add_filter ("mce_buttons", "qcilist_pro_sld_btn");
}

function qcilist_pro_sld_btn_js($plugin_array) {
	$plugin_array['ilist_short_btn'] = plugins_url('assets/js/qcld-tinymce-button.js', __FILE__);
	$plugin_array['ilist_short_btn_chart'] = plugins_url('assets/js/qcld-tinymce-iChart.js', __FILE__);
	return $plugin_array;
}

function qcilist_pro_sld_btn($buttons) {
	array_push ($buttons, 'ilist_short_btn');
	array_push ($buttons, 'ilist_short_btn_chart');
	return $buttons;
}

add_action ('init', 'qcilist_pro_tinymce_button_function'); 



/***************************************
 * custom post edit by ajax...
 ***************************************/

function qcilist_pro_custom_post_type_xhr(){
    global $post;
    if( isset($post->post_type) && ('ilist' === $post->post_type)){
        $post_url = admin_url('post.php'); #In case we're on post-new.php
        echo "
        <script>
            jQuery(document).ready(function($){
                //Click handler - you might have to bind this click event another way
                //$('a.ilist-fancybox-show').click(function(){
                $(document).on( 'click', 'a.ilist-fancybox-show', function(){	

                    //Post to post.php
                    var postURL = '$post_url';

                    //Collate all post form data
                    var data = $('form#post').serializeArray();

                    //Set a trigger for our save_post action
                    data.push({foo_doing_ajax: true});

                    //The XHR Goodness
                    $.post(postURL, data, function(response){
                       
                    });
                    return false;
                });
            });
        </script>";
    }
}
add_action('admin_head-post.php', 'qcilist_pro_custom_post_type_xhr');
add_action('admin_head-post-new.php', 'qcilist_pro_custom_post_type_xhr');

add_action('save_post', 'qcilist_pro_save_my_custom_post_type');
function qcilist_pro_save_my_custom_post_type($post_id){
    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) return;

    #If this is your post type
    if(isset($_POST['post_type']) && ('ilist' === $_POST['post_type'])){
        //Save any post meta here

        #We conditionally exit so we don't return the full wp-admin load if foo_doing_ajax is true
        if(isset($_POST['foo_doing_ajax']) && $_POST['foo_doing_ajax'] === true){
            header('Content-type: application/json');
            #Send a response
            echo json_encode(array('success' => true));
            exit;
            #You should keep this conditional to degrade gracefully for no JS
        }
    }
}



add_action('wp_ajax_ilist_embaded_list_url_info', 'qcilist_pro_embaded_list_url_info');
add_action('wp_ajax_nopriv_ilist_embaded_list_url_info', 'qcilist_pro_embaded_list_url_info');

function qcilist_pro_embaded_list_url_info(){

	check_ajax_referer( 'qcld-ilist', 'security');

    $post_id  						= sanitize_text_field($_POST['post_id']);
    $shortcode_main_title 			= get_post_meta( $post_id, 'shortcode_main_title' );
    $shortcode_embed_option 		= get_post_meta( $post_id, 'shortcode_embed_option' );
    $shortcode_boxed_layout 		= get_post_meta( $post_id, 'shortcode_boxed_layout' );
    $shortcode_column 				= get_post_meta( $post_id, 'shortcode_column' );
    $shortcode_display_copy_share 	= get_post_meta( $post_id, 'shortcode_display_copy_share' );
    $shortcode_upvote 				= get_post_meta( $post_id, 'shortcode_upvote' );
    $post_type_radio_sl 			= get_post_meta( $post_id, 'post_type_radio_sl' );

    if($post_type_radio_sl[0] ==  'textlist' ){ 
    	$shortcode_list_style = get_post_meta( $post_id, 'qcld_sl_template_text');
    }else if($post_type_radio_sl[0] ==  'imagelist' ){
    	$shortcode_list_style = get_post_meta( $post_id, 'qcld_sl_template_image');
    }else if($post_type_radio_sl[0] ==  'multipage' ){
    	$shortcode_list_style = get_post_meta( $post_id, 'qcld_sl_template_multipage');
    }else{
    	$shortcode_list_style = get_post_meta( $post_id, 'qcld_sl_template_mix');
    }

    /*$embaded_url = site_url()."/embed-ilist/?order=ASC&mode=one&list_id=".esc_attr($post_id)."&style=".$shortcode_list_style[0]."&column=".$shortcode_column[0]."&display_copy_share=".$shortcode_display_copy_share[0]."&embed_option=".$shortcode_embed_option[0]."&main_title=".$shortcode_main_title[0]."&upvote=".$shortcode_upvote[0]."&capture=true&boxed_layout=".$shortcode_boxed_layout[0];*/

    $embaded_url = site_url()."/embed-ilist/?order=ASC&mode=one&list_id=".esc_attr($post_id)."&style=".$shortcode_list_style[0]."&column=".$shortcode_column[0]."&display_copy_share=".$shortcode_display_copy_share[0]."&embed_option=".$shortcode_embed_option[0]."&main_title=".$shortcode_main_title[0]."&boxed_layout=".$shortcode_boxed_layout[0]."&upvote=".$shortcode_upvote[0]."&capture=true";

    $shortcode_generate = '[qcld-ilist mode="one" list_id="'.esc_attr($post_id).'"  style="'.$shortcode_list_style[0].'" upvote="'.$shortcode_upvote[0].'" main_title="'.$shortcode_main_title[0].'" embed_option="'.$shortcode_embed_option[0].'" boxed_layout="'.$shortcode_boxed_layout[0].'" column="'.$shortcode_column[0].'" display_copy_share="'.$shortcode_display_copy_share[0].'"]' .'<br>'. '<p> '.esc_html("You can also use the iList Shortcode Generator in your page for additional options.", "qc-opd").' </p>' ;


    wp_reset_query();
    $response = array(
        'html' 			=> $embaded_url,
        'short_code' 	=> $shortcode_generate,
    );
    echo wp_send_json($response);
    wp_die();

}




add_action( 'cmb2_admin_init', 'ilist_drag_drop_shortcode_register_appearance_metabox' );
function ilist_drag_drop_shortcode_register_appearance_metabox() {
	
	$cmb_shortcode = new_cmb2_box( array(
		'id'            => 'ilist_shortcode_drag_drop_id',
		'title'         => esc_html__( 'Settings', 'qc-opd' ),
		'object_types'  => array( 'qc_ilist_drag_drop' ), // Post type
		'closed'     	=> true,
		'classes'    	=> 'extra-class',
	) );


	// shortcode feature...

	$shortcode_1 = $cmb_shortcode->add_field( array(
		'name'    	=> __( 'Template Mode', 'qc-opd' ),
		'id'      	=> 'shortcode_drag_drop_template_mode',
		'desc' 	  	=> __('Change Template Mode', 'qc-opd' ),
		'type'    	=> 'radio_inline',
		'options' 	=> array(
			'slider' 	=> __( 'Slider', 'qc-opd' ),
			'normal' 	=> __( 'Normal', 'qc-opd' ),
		),
		'default' 	=> 'slider',
	) );

	$shortcode_2 = $cmb_shortcode->add_field( array(
		'name'    => __( 'Width (px)', 'qc-opd' ),
		'id'      => __( 'shortcode_drag_drop_template_width', 'qc-opd' ),
		'desc' 	  => __( 'Change Template Width (Default:400px)', 'qc-opd' ),
		'type'    => 'text_small',
		'default' => '400',
	) );


	$shortcode_3 = $cmb_shortcode->add_field( array(
		'name'    => __( 'Height (px)', 'qc-opd' ),
		'id'      => 'shortcode_drag_drop_template_height',
		'desc' 	  => __( 'Change Template Height (Default:600px)', 'qc-opd' ),
		'type'    => 'text_small',
		'default' => '600',
	) );

	// shortcode feature...
	//Code for create column
	$cmb2Grid = new \Cmb2Grid\Grid\Cmb2Grid($cmb_shortcode);
	// shortcode generate...
	$row = $cmb2Grid->addRow();
	$row->addColumns(array($shortcode_1, $shortcode_2,$shortcode_3));
	

}